package net.bjoerks.httpgetpostrequest_assertxmlreq_asynk;

import android.app.Activity;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuItem;
import android.app.Activity;
import android.content.Context;
import android.os.AsyncTask;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.webkit.WebView;
import android.widget.TextView;
import android.widget.Toast;

import java.io.BufferedReader;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.io.Reader;
import java.io.StringReader;
import java.net.HttpURLConnection;
import java.net.URL;

import org.apache.http.Header;
import org.apache.http.HttpResponse;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.protocol.HTTP;
import org.xmlpull.v1.XmlPullParser;
import org.xmlpull.v1.XmlPullParserFactory;


public class HttpGetPostRequest_AssertXmlReq_Asynk extends Activity {

    private TextView textView1;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        textView1 = (TextView)this.findViewById(R.id.textView1);

        this.findViewById(R.id.buttonGetSide).setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View v) {
                onClick_buttonGetSide(v);
            }
        });

        this.findViewById(R.id.buttonSoapSubtract).setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View v) {
                onClick_buttonSoapSubtract(v);
            }
        });

        this.findViewById(R.id.buttonSoapPersoner).setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View v) {
                onClick_buttonSoapPersoner(v);
            }
        });

        this.findViewById(R.id.buttonSoapPersonerMedPostnr).setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View v) {
                onClick_buttonSoapPersonerMedPostnr(v);
            }
        });


    }

    private void onClick_buttonGetSide(View v) {
        try {

            TextView textView1 = (TextView)this.findViewById(R.id.textView1);
            String response = DataHelper.getHttpGetRequest("http://bjoerks.net/http/", "text/html");
            textView1.setText(response);
        }
        catch (Exception e){
            Toast.makeText(this, "Fejl: "+e.getMessage(), Toast.LENGTH_LONG);
        }
    }

    private void onClick_buttonSoapSubtract(View v) {
        TextView textView1 = (TextView)this.findViewById(R.id.textView1);
        String response = doSoapSubtractRequest(5,8);
        textView1.setText(response);
        int b = response.indexOf("<SubtractResult>");
        int e = response.indexOf("</SubtractResult>");
        if (b<e) {
            response = response.substring(b+"<SubtractResult>".length(), e);
            textView1.append("\n\n\n\nResultatet var: <"+response+">");
        }
    }

    private void onClick_buttonSoapPersoner(View v) {
        TextView textView1 = (TextView)this.findViewById(R.id.textView1);
        String response = doSoapAsmxCall_GetAllePersoner();
        textView1.setText(response);
    }

    private void onClick_buttonSoapPersonerMedPostnr(View v) {
        TextView textView1 = (TextView)this.findViewById(R.id.textView1);
//        String response = doSoapWcfCall_GetAllePersonerMedPostnr(5200, 5210, false);
        //       textView1.setText(response);

        doGetPersonerAync dg = new doGetPersonerAync();
        dg.execute(5200, 5210, 1);
    }

    public String doSoapSubtractRequest(int a, int b) {
        try {

            String soapPostReqText = DataHelper.readAssetFileIntoString(this, "soapAsmxCall_Subtract.xml");

            soapPostReqText = soapPostReqText.replace("@param_a", ""+a);
            soapPostReqText = soapPostReqText.replace("@param_b", ""+b);

            return DataHelper.getHttpPostRequest("http://webservicedemo.bjoerks.net/RegneWebService.asmx",
                    "text/xml; charset=utf-8",
                    "http://tempuri.org/Subtract",
                    soapPostReqText);
        }
        catch (Exception e){
            Toast.makeText(this, "Fejl: "+e.getMessage(), Toast.LENGTH_LONG);
            return "Error: returmsg=<"+e.getMessage()+">\n";
        }
    }

    public String doSoapAsmxCall_GetAllePersoner() {
        try {

            String soapPostReqText = DataHelper.readAssetFileIntoString(this, "SoapAsmxCall_GetAllePersoner.xml");

            return DataHelper.getHttpPostRequest("http://webservicedemo.bjoerks.net/PersonWebService.asmx",
                    "text/xml; charset=utf-8",
                    "http://tempuri.org/GetAllePersoner",
                    soapPostReqText);
        }
        catch (Exception e){
            Toast.makeText(this, "Fejl: "+e.getMessage(), Toast.LENGTH_LONG);
            return "Error: returmsg=<"+e.getMessage()+">\n";
        }
    }


    public String doSoapWcfCall_GetAllePersonerMedPostnr(int fraPostnr, int tilPostnr, boolean orderEfternavnFornavn) {
        try {

            String soapPostReqText = DataHelper.readAssetFileIntoString(this, "SoapWcfCall_GetAllePersonerMedPostnr.xml");

            soapPostReqText = soapPostReqText.replace("@param_fraPostnr", ""+fraPostnr);
            soapPostReqText = soapPostReqText.replace("@param_tilPostnr", ""+tilPostnr);
            if (orderEfternavnFornavn)
                soapPostReqText = soapPostReqText.replace("@param_orderEfternavnFornavn", "true");
            else
                soapPostReqText = soapPostReqText.replace("@param_orderEfternavnFornavn", "false");

            return DataHelper.getHttpPostRequest("http://webservicedemo.bjoerks.net/PersonWcfService.svc/soap",
                    "text/xml; charset=utf-8",
                    "http://tempuri.org/IPersonWcfService/GetAllePersonerMedPostnr",
                    soapPostReqText);
        }
        catch (Exception e){
            Toast.makeText(this, "Fejl: "+e.getMessage(), Toast.LENGTH_LONG);
            return "Error: returmsg=<"+e.getMessage()+">\n";
        }
    }

    public void XmlParseResult(String result) {
        try {

            XmlPullParserFactory factory = XmlPullParserFactory.newInstance();
            factory.setNamespaceAware(true);
            XmlPullParser xpp = factory.newPullParser();
            xpp.setInput(new StringReader(result));
            int eventType = xpp.getEventType();
            while (eventType != XmlPullParser.END_DOCUMENT) {
                if(eventType == XmlPullParser.START_DOCUMENT) {
                    System.out.println("Start document");
                } else if(eventType == XmlPullParser.START_TAG) {
                    System.out.println("Start tag "+xpp.getName());
                } else if(eventType == XmlPullParser.END_TAG) {
                    System.out.println("End tag "+xpp.getName());
                } else if(eventType == XmlPullParser.TEXT) {
                    System.out.println("Text "+xpp.getText());
                }
                eventType = xpp.next();
            }
        }
        catch (Exception e){
            textView1.setText("Error: ved XML-Parsing"+e.getMessage());
        }
    }


    private class doGetPersonerAync extends AsyncTask<Integer, Void, String> {
        @Override
        protected String doInBackground(Integer... data) {
            try {
                int fraPostnr = data[0];
                int tilPostnr = data[1];
                boolean orderEfternavnFornavn = data[2]!=0;
                String response = doSoapWcfCall_GetAllePersonerMedPostnr(fraPostnr, tilPostnr, orderEfternavnFornavn);
                return response;
            }
            catch (Exception e){
                return "Error: "+e.getMessage();
            }
        }


        @Override
        protected void onPostExecute(String result) {
            textView1.setText(result);

            XmlParseResult(result);
        }



    }





    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement
        if (id == R.id.action_settings) {
            return true;
        }

        return super.onOptionsItemSelected(item);
    }
}
